//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4837034D0275.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4837034D0275.cm

//## begin module%4837034D0275.cp preserve=no
//## end module%4837034D0275.cp

//## Module: ModelExprContexts%4837034D0275; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/ModelExprContexts.h

#ifndef MODELEXPRCONTEXTS_H
#define MODELEXPRCONTEXTS_H 1

//## begin module%4837034D0275.additionalIncludes preserve=no
//## end module%4837034D0275.additionalIncludes

//## begin module%4837034D0275.includes preserve=yes
#include <xsTypes.h>
#include <XSUtil/Parse/XSModExpTree.h>
#include <utility>

template <typename T>
class ModelExpression;
//## end module%4837034D0275.includes

//## begin module%4837034D0275.declarations preserve=no
//## end module%4837034D0275.declarations

//## begin module%4837034D0275.additionalDeclarations preserve=yes
class ModExprTreeMember;
//## end module%4837034D0275.additionalDeclarations


//## Class: ModelExprTree%48403DCA02A6
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef XSModExpTree<ModelExpression<ModExprTreeMember> > ModelExprTree;

//## begin ModExprTreeMember%4837059E03C4.preface preserve=yes
//## end ModExprTreeMember%4837059E03C4.preface

//## Class: ModExprTreeMember%4837059E03C4
//	This implements functionality specific to Model
//	Expressions when they are used as sub-expressions in an
//	expression tree.  The major distinction between this and
//	a stand-alone context is that it ASSUMES the expression
//	string corresponds to an Xspec ComponentGroup, ie. at
//	most 1 pair of parentheses and no plus signs outside of
//	parentheses.  It also contains additional data members
//	for storing tree position information.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ModExprTreeMember 
{
  //## begin ModExprTreeMember%4837059E03C4.initialDeclarations preserve=yes
   friend class ModExprStandAlone;
  //## end ModExprTreeMember%4837059E03C4.initialDeclarations

  public:
    //## Class: HostClass%483ECE3B030F
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef ModelExpression<ModExprTreeMember> HostClass;

    //## Destructor (generated)
      virtual ~ModExprTreeMember();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: location%48370EDC035A
      //	This is the expression's 0-based post-order tree
      //	position.
      int location () const;

      //## Attribute: group%48370FBA01E0
      //	The group number is the location number of the top-level
      //	component group which contains this sub-expression.  A
      //	distinguishing feature of top-level expressions is that
      //	their group and location numbers are equal.
      int group () const;

      //## Attribute: parenLocs%48371086028F
      //	The location in the expression string of the one allowed
      //	pair of parentheses.  If there is no pair, the values
      //	will be set to npos.
      std::pair<size_t,size_t> parenLocs () const;

      //## Attribute: plusLocs%483710F4010C
      const std::vector<size_t>& plusLocs () const;

  public:
    // Additional Public Declarations
      //## begin ModExprTreeMember%4837059E03C4.public preserve=yes
      //## end ModExprTreeMember%4837059E03C4.public

  protected:
    //## Constructors (generated)
      ModExprTreeMember();


    //## Other Operations (specified)
      //## Operation: contextSpecificInit%483F00EE01AF
      //	Store locations of parentheses and plus signs, if any.
      void contextSpecificInit (HostClass* host);

      //## Operation: setComponentSequence%4849642F0326
      //	This exists merely to provide this class with
      //	polymorphic access to the inhereting HostClass's version
      //	of the function.
      virtual void setComponentSequence (int seq, int index) = 0;

      //## Operation: Swap%484FE59E02C7
      void Swap (ModExprTreeMember& right);

    // Additional Protected Declarations
      //## begin ModExprTreeMember%4837059E03C4.protected preserve=yes
      //## end ModExprTreeMember%4837059E03C4.protected

  private:
    //## Assignment Operation (generated)
      ModExprTreeMember & operator=(const ModExprTreeMember &right);


    //## Other Operations (specified)
      //## Operation: sequenceSubExpressions%483C461D0353
      static void sequenceSubExpressions (ModelExprTree::iterator& itExp, int& wordStart);

    // Additional Private Declarations
      //## begin ModExprTreeMember%4837059E03C4.private preserve=yes
      //## end ModExprTreeMember%4837059E03C4.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ModExprTreeMember::location%48370EDC035A.attr preserve=no  public: int {U} 
      int m_location;
      //## end ModExprTreeMember::location%48370EDC035A.attr

      //## begin ModExprTreeMember::group%48370FBA01E0.attr preserve=no  public: int {U} 
      int m_group;
      //## end ModExprTreeMember::group%48370FBA01E0.attr

      //## begin ModExprTreeMember::parenLocs%48371086028F.attr preserve=no  public: std::pair<size_t,size_t> {U} 
      std::pair<size_t,size_t> m_parenLocs;
      //## end ModExprTreeMember::parenLocs%48371086028F.attr

      //## begin ModExprTreeMember::plusLocs%483710F4010C.attr preserve=no  public: std::vector<size_t> {U} 
      std::vector<size_t> m_plusLocs;
      //## end ModExprTreeMember::plusLocs%483710F4010C.attr

    // Additional Implementation Declarations
      //## begin ModExprTreeMember%4837059E03C4.implementation preserve=yes
      //## end ModExprTreeMember%4837059E03C4.implementation

};

//## begin ModExprTreeMember%4837059E03C4.postscript preserve=yes
//## end ModExprTreeMember%4837059E03C4.postscript

//## begin ModExprStandAlone%483708BF038F.preface preserve=yes
//## end ModExprStandAlone%483708BF038F.preface

//## Class: ModExprStandAlone%483708BF038F
//	This implements functionality that is specific to Model
//	Expressions when they exist as a single stand-alone
//	object rather than parts of tree.  It assumes the
//	expression strings can have all of the complexity
//	allowed under Xspec's model command, including
//	parentheses nested to arbitrary depth.  It can also
//	create a tree of sub-expressions from itself.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ModExprStandAlone 
{
  //## begin ModExprStandAlone%483708BF038F.initialDeclarations preserve=yes
  //## end ModExprStandAlone%483708BF038F.initialDeclarations

  public:
    //## Class: HostClass%483ECE7502DC
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef ModelExpression<ModExprStandAlone> HostClass;

    //## Destructor (generated)
      virtual ~ModExprStandAlone() = 0;


    //## Other Operations (specified)
      //## Operation: createExpTree%48373FEC00E3;              C++
      void createExpTree (ModelExprTree& expTree) const;

  public:
    // Additional Public Declarations
      //## begin ModExprStandAlone%483708BF038F.public preserve=yes
      //## end ModExprStandAlone%483708BF038F.public

  protected:
    //## Constructors (generated)
      ModExprStandAlone();


    //## Other Operations (specified)
      //## Operation: contextSpecificInit%483F00A1035B
      void contextSpecificInit (HostClass* host);

      //## Operation: Swap%484FE5450264
      void Swap (ModExprStandAlone& right);

    // Additional Protected Declarations
      //## begin ModExprStandAlone%483708BF038F.protected preserve=yes
      //## end ModExprStandAlone%483708BF038F.protected

  private:
    //## Assignment Operation (generated)
      ModExprStandAlone & operator=(const ModExprStandAlone &right);


    //## Other Operations (specified)
      //## Operation: findGroups%48373FEC0189;             C++
      static std::vector<string::size_type> findGroups (const string& inString);

      //## Operation: makeSubExpressions%48373FEC0231
      static void makeSubExpressions (const string& inString, ModelExprTree& expTree);

      //## Operation: findNests%48373FEC02E7
      static std::vector<string::size_type> findNests (const string& inString);

    // Additional Private Declarations
      //## begin ModExprStandAlone%483708BF038F.private preserve=yes
      //## end ModExprStandAlone%483708BF038F.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fullExprString%484431BB0002
      //	This is just a local copy of the Host class m_expr
      //	String.  Needed for createExpTree.
      //## begin ModExprStandAlone::fullExprString%484431BB0002.attr preserve=no  private: string {U} 
      string m_fullExprString;
      //## end ModExprStandAlone::fullExprString%484431BB0002.attr

    // Additional Implementation Declarations
      //## begin ModExprStandAlone%483708BF038F.implementation preserve=yes
      //## end ModExprStandAlone%483708BF038F.implementation

};

//## begin ModExprStandAlone%483708BF038F.postscript preserve=yes
//## end ModExprStandAlone%483708BF038F.postscript

// Class ModExprTreeMember 

inline ModExprTreeMember::~ModExprTreeMember()
{
  //## begin ModExprTreeMember::~ModExprTreeMember%4837059E03C4_dest.body preserve=yes
  //## end ModExprTreeMember::~ModExprTreeMember%4837059E03C4_dest.body
}


//## Get and Set Operations for Class Attributes (inline)

inline int ModExprTreeMember::location () const
{
  //## begin ModExprTreeMember::location%48370EDC035A.get preserve=no
  return m_location;
  //## end ModExprTreeMember::location%48370EDC035A.get
}

inline int ModExprTreeMember::group () const
{
  //## begin ModExprTreeMember::group%48370FBA01E0.get preserve=no
  return m_group;
  //## end ModExprTreeMember::group%48370FBA01E0.get
}

inline std::pair<size_t,size_t> ModExprTreeMember::parenLocs () const
{
  //## begin ModExprTreeMember::parenLocs%48371086028F.get preserve=no
  return m_parenLocs;
  //## end ModExprTreeMember::parenLocs%48371086028F.get
}

inline const std::vector<size_t>& ModExprTreeMember::plusLocs () const
{
  //## begin ModExprTreeMember::plusLocs%483710F4010C.get preserve=no
  return m_plusLocs;
  //## end ModExprTreeMember::plusLocs%483710F4010C.get
}

// Class ModExprStandAlone 

//## begin module%4837034D0275.epilog preserve=yes
inline ModExprStandAlone::~ModExprStandAlone() {}
//## end module%4837034D0275.epilog


#endif
